package imagemed.layout.validator;

import imagemed.util.LocalizedMessage;
import java.text.Format;

public class DefaultdevicecatValidator extends DBValidator {

	@Override
	protected void preValidate() {
		setMandatoryWarning( "DCNA" );

	}

	@Override
	public void validate() {

		String maxConn = getValue( "DCRN" );
		if ( !"".equals( maxConn ) ) {
			try {
				Integer.parseInt( maxConn );
			}
			catch ( NumberFormatException ex ) {
				m_errors.add( LocalizedMessage.getCompoundMessage( "DEFAULT_DEVICE_VALIDATOR_MUST_BE_INTEGER", new Format[]{ null }, new Object[]{ getLabel( "DCRN" ) } , false ) );
			}
		}

		//detect loop
		String myID = getValue( "DCID" );
		String actID = getValue( "DCPA" );
		while ( !"-1".equals( actID ) ) {
			if ( actID.equals( myID ) ) {
				m_errors.add( LocalizedMessage.getCompoundMessage( "DEFAULT_DEVICE_VALIDATOR_LOOP_IN_CATEGORIES", new Format[]{ null }, new Object[]{ getLabel( "DCPA" ) } , false )  );
				break;
			}
			RecordIterator actRecord = getExternalRecord( m_deviceCategoryTable, actID );
			actRecord.next();
			actID = actRecord.getValue( "DCPA" );
		}

	}


}
