package imagemed.layout.validator;

import imagemed.jsputil.IMAdminToolbox;
import imagemed.util.LocalizedMessage;

import java.util.*;

public class DefaultldapConfigValidator extends DBValidator {

	private static Set<String> RESERVED_IDS = new HashSet<String>();

	static {
		RESERVED_IDS.add( IMAdminToolbox.AUTH_EP );
		RESERVED_IDS.add( IMAdminToolbox.AUTH_GRP );
		RESERVED_IDS.add( IMAdminToolbox.AUTH_SYS );
	}

	@Override
	protected void preValidate() {
		setMandatoryError( "LDID" );
		setMandatoryError( "LDSU" );
	}

	@Override
	public void validate() {

		mustBeUnique( "LDID", m_ldapConfPage, false );

		if ( RESERVED_IDS.contains( getValue( "LDID" ) ) ) {
			m_errors.add( getValue( "LDID" ) + " " + LocalizedMessage.getSimpleMessage( "LDAPCONFIGVALIDATOR_ID_RESERVED" ) );
		}

	}

}
