package imagemed.layout.validator;

import imagemed.util.LocalizedMessage;



public class DefaultlocationValidator extends DBValidator {

	@Override
	protected void preValidate() {

		setMandatoryError( "LOUI" );
		setMandatoryError( "LONA" );
		setMandatoryError( "LOTZ" );
	}

	@Override
	public void validate() {

		mustBeUnique( "LOUI", m_locationPage, false );
		mustBeUnique( "LONA", m_locationPage, false );

		if ( LocalizedMessage.getSimpleMessage( "INDEX_LOCATION_OTHER" ).equals( getValue( "LONA" ) ) ) {
			m_errors.add( getValue( "LONA" ) + " " + LocalizedMessage.getSimpleMessage( "LOCATIONVALIDATOR_NAME_RESERVED" ) );
		}

		for ( RecordIterator userLoc = getIterator( m_userLocationTable ); userLoc.next(); ) {

			// If this is the default location for a user, set every other location not default for that user 
			if ( "yes".equals( userLoc.getValue( "ULDU" ) ) ) {
				String actID = userLoc.getValue( "ULID" );
				String actUser = userLoc.getValue( "ULUI" );
				setEachRecordsValue( m_userLocationTable, "ULDU", "no", "ULID", actID, "ULUI", actUser );
			}
		}
	}

}
